; =============================================
; Iterated Function System (IFS) Fractal Viewer
; Andres Amaya Jr.
; Denver, CO
; 2015.01.25
; =============================================

AppTitle "IFS Fractals"
Graphics 1024,768,32,2
Dim a#(1),b#(1),c#(1),d#(1),e#(1),f#(1)
Dim p#(1)
Dim rr%(24), gg%(24), bb%(24), hxc%(24)

cx% =  512 : cy% = 384
SeedRnd MilliSecs()
For ii% = 1 To 2000:kk%=Rand(1,100):Next

Gosub palette
band# = 17.0 : coff# = 1.0

choice = 0
picName$ = "Binary"  : Restore binaryData


speed = 0

Repeat
	Cls
	Gosub readData
	xalt# = 0.5 : yalt# = 0.5
	st = MilliSecs()
	If speed = 1 Then	;very fast rendering
		speed1(choice%, numRows%, xalt#, yalt#, xMult#, yMult#, xOffset%, yOffset%, band#, coff#)
	Else				;watch the pixels plotting	
		speed0(choice%, numRows%, xalt#, yalt#, xMult#, yMult#, xOffset%, yOffset%, band#, coff#)	
	End If
	et = (MilliSecs()-st)

	Color 64,192,255
	Text 5,5, picName$
	;Text 5,750,"et: "+et  ;<---- uncomment this line to display rendering times
	Flip

	response = Menu()
	Select response
		Case 1
			hiY = 5 : choice = (choice + 1) Mod 34
		Case 2
			hiY = 30 : choice = choice - 1 
			If choice < 0 Then choice = 33
		Case 3
			hiY = 55 : speed = 1
		Case 4
			hiY = 80 : speed = 0
		Case 5
			hilite(980,105,38,19)
			Flip
			Delay 400
			End
	End Select
	hilite(980,hiY,38,19)
	Flip
	Delay 200
	If KeyHit(1)>0 Then End


	Select choice
		Case 0 : picName$ = "IFS Binary"			: Restore binaryData
		Case 1 : picName$ = "IFS Coral"				: Restore coralData
		Case 2 : picName$ = "IFS Crystal"			: Restore crystalData
		Case 3 : picName$ = "IFS Dragon"			: Restore dragonData
		Case 4 : picName$ = "IFS Fern"				: Restore fernData
		Case 5 : picName$ = "IFS Floor"				: Restore floorData
		Case 6 : picName$ = "IFS FractInt"			: Restore fractintData
		Case 7 : picName$ = "IFS Koch 3"			: Restore koch3_Data
		Case 8 : picName$ = "IFS Spiral"			: Restore spiralData
		Case 9 : picName$ = "IFS Swirl 5"			: Restore swirl5Data
		Case 10: picName$ = "IFS Tree"				: Restore treeData
		Case 11: picName$ = "IFS Triangle"			: Restore triangleData
		Case 12: picName$ = "IFS Zigzag 2"			: Restore zigzag2Data
		Case 13: picName$ = "Cluster"				: Restore clusterData
		Case 14: picName$ = "Diamond"				: Restore diamantData
		Case 15: picName$ = "Fantasiegebilde 1" 	: Restore fantasiegebilde1Data
		Case 16: picName$ = "Fantasiegebilde 2" 	: Restore fantasiegebilde2Data
		Case 17: picName$ = "Spring"	           	: Restore federData
		Case 18: picName$ = "Spruce"            	: Restore fichteData
		Case 19: picName$ = "Fountain"          	: Restore fontaeneData
		Case 20: picName$ = "Pentagon"          	: Restore fuenfeckData
		Case 21: picName$ = "Galaxy"            	: Restore galaxieData
		Case 22: picName$ = "Cantor's Garden"   	: Restore gartenData
		Case 23: picName$ = "Koch Curve"        	: Restore kochKurveData
		Case 24: picName$ = "Quadratic Koch Curve"	: Restore quadKochData
		Case 25: picName$ = "Minkowski Fractal"		: Restore minkowskiData
		Case 26: picName$ = "Snail Shell"			: Restore schneckenhausData
		Case 27: picName$ = "Cord"					: Restore schnurData
		Case 28: picName$ = "Sierpinski's Carpet"	: Restore sierpCarpetData
		Case 29: picName$ = "Sierpinski's Triangle"	: Restore sierpinskiTriData
		Case 30: picName$ = "Sierpinski Tri Distort": Restore sierpTriData
		Case 31: picName$ = "Bricks"				: Restore steineData
		Case 32: picName$ = "Maple Leaf"			: Restore spitzahornblattData
		Case 33: picName$ = "Branch"				: Restore zweigData
	End Select
Forever

.readData
	Read numRows%
	Dim a(numRows),b(numRows),c(numRows),d(numRows),e(numRows),f(numRows),p(numRows)
	Read xMult#,   yMult#
	Read xOffset%, yOffset%
	For ii = 1 To numRows
		Read a(ii),b(ii),c(ii),d(ii),e(ii),f(ii),p(ii)
		p(ii) = p(ii) + p(ii-1)
	Next
Return

;============================================================================
;	These affine transformation values are from MANPWIN.IFS
;============================================================================
.fern3Ddata
Data 4 			;number of rows (coefficients)
Data 75.0, 75.0 ;x and y magnification factors
Data 512, -12	;x and y offsets
;3dfern (3D) {
Data  0.00,  0.00, 0.0, 0.0, 0.18, 0.0, 0.0,  0.0, 0.00, 0.0, 0.0, 0.0, 0.01
Data  0.85,  0.00, 0.0, 0.0, 0.85, 0.1, 0.0, -0.1, 0.85, 0.0, 1.6, 0.0, 0.85
Data  0.20, -0.20, 0.0, 0.2, 0.20, 0.0, 0.0,  0.0, 0.30, 0.0, 0.8, 0.0, 0.07
Data -0.20,  0.20, 0.0, 0.2, 0.20, 0.0, 0.0,  0.0, 0.30, 0.0, 0.8, 0.0, 0.07

.binaryData
Data 3 			;number of rows (coefficients)
Data 75.0, 75.0 ;x and y magnification factors
Data 512, -9	;x and y offsets
;binary {
Data 0.5,  0.0, 0.0, 0.5, -2.563477, -0.000003, 0.333333
Data 0.5,  0.0, 0.0, 0.5,  2.436544, -0.000003, 0.333333
Data 0.0, -0.5, 0.5, 0.0,  4.873085,  7.563492, 0.333333

.coralData
Data 3 			;number of rows (coefficients)
Data 75.0, 75.0 ;x and y magnification factors
Data 512, -12	;x and y offsets
;coral {
Data 0.307692, -0.531469, -0.461538, -0.293706,  5.401953, 8.655175, 0.40
Data 0.307692, -0.076923,  0.153846, -0.447552, -1.295248, 4.152990, 0.15
Data 0.000000,  0.545455,  0.692308, -0.195804, -4.893637, 7.269794, 0.45

.crystalData
Data 2 			;number of rows (coefficients)
Data 95.0, 75.0 ;x and y magnification factors
Data 490, -7	;x and y offsets
;crystal {
Data 0.696970, -0.4810610, -0.393939, -0.662879, 2.147003, 10.310288, 0.747826
Data 0.090909, -0.4431820,  0.515152, -0.094697, 4.286558,  2.925762, 0.252174

.dragonData
Data 2			;number of rows (coefficients)
Data 74.0, 74.0 ;x and y magnification factors
Data 510, -18	;x and y offsets
;dragon {
Data 0.824074, 0.281482, -0.212346,  0.864198, -1.882290, -0.110607, 0.787473
Data 0.088272, 0.520988, -0.463889, -0.377778,  0.785360,  8.095795, 0.212527

.fernData
Data 4			 ;number of rows (coefficients)
Data 106.0, 76.0 ;x and y magnification factors
Data 480, -3	 ;x and y offsets
;fern {
Data  0.00,  0.00,  0.00, 0.16, 0.0, 0.00, 0.01
Data  0.85,  0.04, -0.04, 0.85, 0.0, 1.60, 0.85
Data  0.20, -0.26,  0.23, 0.22, 0.0, 1.60, 0.07
Data -0.15,  0.28,  0.26, 0.24, 0.0, 0.44, 0.07

.floorData
Data 3			;number of rows (coefficients)
Data 75.0, 75.0 ;x and y magnification factors
Data 512, -10	;x and y offsets
;floor {
Data 0.0, -0.5,  0.5, 0.0, -1.732366, 3.366182, 0.333333
Data 0.5,  0.0,  0.0, 0.5, -0.027891, 5.014877, 0.333333
Data 0.0,  0.5, -0.5, 0.0,  1.620804, 3.310401, 0.333333

.fractintData
Data 23 		;number of rows (coefficients)	
Data 72.0, 72.0 ;x and y magnification factors
Data 512, 0		;x and y offsets
;fractint { ; by Pieter Branderhorst
Data  0.00, -0.11,  0.22,  0.00, -6.25, 4.84, 0.06
Data  0.11,  0.02,  0.00,  0.11, -6.30, 5.99, 0.03
Data  0.06,  0.02,  0.00,  0.10, -6.25, 4.51, 0.02
Data  0.00, -0.11,  0.22,  0.00, -4.34, 4.84, 0.06
Data  0.08,  0.00,  0.00,  0.11, -4.50, 5.99, 0.02
Data  0.00,  0.11, -0.08,  0.00, -4.30, 6.15, 0.02
Data -0.09,  0.00, -0.01, -0.13, -4.15, 5.94, 0.02
Data  0.06,  0.11, -0.13,  0.00, -4.69, 4.15, 0.04
Data  0.03, -0.11,  0.23,  0.11, -2.26, 4.43, 0.07
Data  0.03,  0.11, -0.25,  0.00, -2.57, 4.99, 0.07
Data  0.06,  0.00,  0.00,  0.11, -2.40, 4.46, 0.02
Data  0.00,  0.11, -0.19,  0.00, -1.62, 4.99, 0.06
Data  0.09, -0.01,  0.00,  0.10, -0.58, 2.96, 0.03
Data -0.09,  0.00,  0.00, -0.11, -0.65, 7.10, 0.03
Data  0.12,  0.00, -0.00,  0.11,  1.24, 6.00, 0.03
Data  0.00,  0.11, -0.22,  0.00,  0.68, 4.80, 0.06
Data -0.12,  0.00,  0.00, -0.13,  6.17, 7.18, 0.03
Data  0.00, -0.11,  0.22,  0.00,  6.78, 4.84, 0.06
Data  0.00,  0.08, -0.25,  0.02,  2.21, 4.95, 0.07
Data  0.00, -0.11,  0.22,  0.00,  4.10, 4.84, 0.06
Data  0.00, -0.11,  0.22,  0.00,  5.25, 5.23, 0.06
Data  0.08,  0.11, -0.25,  0.00,  3.57, 4.99, 0.08

.koch3_Data
Data 5	 		;number of rows (coefficients)	
Data 84.0, 75.0 ;x and y multiplication factors
Data 512, -8	;x and y offsets
;koch3 {
Data 0.307692, -0.000000,  0.000000,  0.294118,  4.119164, 1.604278, 0.151515
Data 0.192308, -0.205882,  0.653846,  0.088235, -0.688840, 5.978916, 0.253788
Data 0.192308,  0.205882, -0.653846,  0.088235,  0.668580, 5.962514, 0.253788
Data 0.307692, -0.000000,  0.000000,  0.294118, -4.136530, 1.604278, 0.151515
Data 0.384615, -0.000000,  0.000000, -0.294118, -0.007718, 2.941176, 0.189394

.spiralData
Data 3	 		;number of rows (coefficients)	
Data 72.0, 80.0 ;x and y multiplication factors
Data 512, 10	;x and y offsets
;spiral {
Data  0.787879, -0.424242, 0.242424, 0.859848,  1.758647, 1.408065, 0.895652
Data -0.121212,  0.257576, 0.151515, 0.053030, -6.721654, 1.377236, 0.052174
Data  0.181818, -0.136364, 0.090909, 0.181818,  6.086107, 1.568035, 0.052174

.swirl5Data
Data 2	 		;number of rows (coefficients)	
Data 75.0, 75.0 ;x and y multiplication factors
Data 512, -10	;x and y offsets
;swirl5 {
Data  0.745455, -0.459091,  0.406061,  0.887121, 1.460279, 0.691072, 0.912675
Data -0.424242, -0.065152, -0.175758, -0.218182, 3.809567, 6.741476, 0.087325

.treeData
Data 4	 			;number of rows (coefficients)	
Data 1850.0, 1850.0 ;x and y multiplication factors
Data 512, 50		;x and y offsets
;tree {
Data 0.00,	0.00,  0.00, 0.50, 0.0, 0.0, 0.05
Data 0.42, -0.42,  0.42, 0.42, 0.0, 0.2, 0.40
Data 0.42,  0.42, -0.42, 0.42, 0.0, 0.2, 0.40
Data 0.10,	0.00,  0.00, 0.10, 0.0, 0.2, 0.15

.triangleData		;Pascal's triangle
Data 3	 			;number of rows (coefficients)	
Data 375.0, 375.0	;x and y multiplication factors
Data 200, -8		;x and y offsets
;triangle {
Data 0.5, 0.0, 0.0, 0.5, 0.0, 0.0, 0.33
Data 0.5, 0.0, 0.0, 0.5, 0.0, 1.0, 0.33
Data 0.5, 0.0, 0.0, 0.5, 1.0, 1.0, 0.34

.zigzag2Data
Data 2	 		;number of rows (coefficients)	
Data 75.0, 75.0	;x and y multiplication factors
Data 510, -10	;x and y offsets
;zigzag2 {
Data -0.632407, -0.614815, -0.545370, 0.659259, 3.840822, 1.282321, 0.888128
Data -0.036111,  0.444444,  0.210185, 0.037037, 2.071081, 8.330552, 0.111872
;============================================================================
;	End of MANPWIN.IFS values
;============================================================================

;============================================================================
;	These affine transformation values are from RS-IFSPB.BAS
;============================================================================
;===========================================================================
; Subject: ITERATED FUNCTION SYSTEMS          Date: 05-31-96 (16:32)       
;  Author: Robert Seidel                      Code: QB, QBasic, PB         
;  Origin: seidel@ifk.uni-jena.de           Packet: Graphics.ABC
;===========================================================================
.clusterData
Data 3	 			;number of rows (coefficients)
Data 570.0, 415.0	;x and y multiplication factors
Data 695, 60		;x and y offsets
;Cluster
Data  0.5   ,  0.0   , 0.0   ,  0.5   , 0.0 , 1.0 , 0.2
Data  0.353 , -0.353 , 0.353 ,  0.353 , 0.0 , 1.0 , 0.4
Data -0.353 , -0.353 , 0.353 , -0.353 , 0.0 , 1.0 , 0.4
;-1.1 , 0.0 , 0.4 , 2.2 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.diamantData		;Diamond
Data 5	 			;number of rows (coefficients)
Data 1.60, 1.67		;x and y multiplication factors
Data 2, 14			;x and y offsets
;Diamant
Data  0.7333 ,  0.0    ,   0.0    ,   0.2667 , 159.9402 , 342.5262 , 0.23 
Data  0.0    ,  0.3284 ,  -0.5954 ,   0.0    , 446.369  , 369.0742 , 0.23
Data -0.7333 ,  0.0    ,   0.0    ,  -0.2667 , 479.0666 , 136.515  , 0.23
Data  0.0    , -0.3284 ,   0.5954 ,   0.0    , 192.6378 , 109.967  , 0.23
Data -0.2667 , -0.2463 ,   0.2165 ,  -0.0667 , 463.7048 , 186.3117 , 0.08
;30.0    , 10.0    , 610.0    , 510.0 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995) 
;erstellt von Th. Erken unter Verwendung von Angaben aus FDESIGN

.fantasiegebilde1Data	;figment of imagination 1
Data 4	 			;number of rows (coefficients)
Data 1400.0, 860.0	;x and y multiplication factors
Data -240, 100		;x and y offsets
;Fantasiegebilde 1
Data 0.8 ,  0.1 , -0.1 , 0.6 , 0.1 , 0.1 , 0.25
Data 0.6 , -0.1 ,  0.1 , 0.4 , 0.2 , 0.2 , 0.25
Data 0.4 ,  0.1 , -0.1 , 0.2 , 0.3 , 0.6 , 0.25
Data 0.2 ,  0.0 ,  0.0 , 0.2 , 0.4 , 0.8 , 0.25
; 0.0 , 0.0 , 1.0 , 1.1 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.fantasiegebilde2Data	;figment of imagination 1
Data 3	 			;number of rows (coefficients)
Data 350.0, 315.0	;x and y multiplication factors
Data 80, -5			;x and y offsets
;Fantasiegebilde2
Data 0.5   ,  0.0   , 0.0   , 0.5   , 1.0 , 0.0 , 0.33
Data 0.5   ,  0.0   , 0.0   , 0.5   , 1.0 , 1.0 , 0.33
Data 0.353 , -0.353 , 0.353 , 0.353 , 1.0 , 1.0 , 0.34
;0.0 , -0.5 , 2.8 , 3.0 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.federData			;Spring
Data 2	 			;number of rows (coefficients)
Data 35.0, 25.0		;x and y multiplication factors
Data 175, -138		;x and y offsets 
;Feder
Data  0.8241 , -0.2815 ,  0.2123 ,  0.8642 , 7.107 , 0.4142 , 0.8 
Data -0.0722 , -0.4222 , -0.2463 ,  0.0593 , 6.715 , 0.4029 , 0.2 
;-5.5    , -6.5    , 24.5    , 27.0 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995) 
;erstellt von Th. Erken unter Verwendung von Angaben aus FDESIGN

.fichteData			;Spruce
Data 4	 			;number of rows (coefficients)
Data 1100.0, 1200.0	;x and y multiplication factors
Data 5, 320			;x and y offsets 
;Fichte ('Christbaum')
Data 0.6  ,  0.0 ,  0.0 , 0.6 , 0.18 , 0.36 , 0.25
Data 0.6  ,  0.0 ,  0.0 , 0.6 , 0.18 , 0.12 , 0.25
Data 0.4  ,  0.3 , -0.3 , 0.4 , 0.27 , 0.36 , 0.25
Data 0.4  , -0.3 ,  0.3 , 0.4 , 0.27 , 0.09 , 0.25
;0.07 ,  0.25,  0.85, 0.95 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.fontaeneData		;Fountain
Data 3	 			;number of rows (coefficients)
Data 25.0, 17.0		;x and y multiplication factors
Data 512, -662		;x and y offsets 
;Fontaene
Data 0.0  ,  0.0 ,  0.0 , 0.9  ,  0.0 , -6.0 , 0.33
Data 0.85 , -0.2 ,  0.2 , 0.85 , -0.8 ,  0.8 , 0.33
Data 0.85 ,  0.2 , -0.2 , 0.85 ,  0.8 ,  0.8 , 0.34
;-20  , -37  , 22   , 10 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.fuenfeckData		;Pentagon
Data 5	 			;number of rows (coefficients)
Data 860.0, 830.0	;x and y multiplication factors
Data 85, 70			;x and y offsets 
;Fuenfecke
Data 0.382 ,  0.0  , 0.0  , 0.382 , 0.3072 , 0.6190 , 0.2
Data 0.382 ,  0.0  , 0.0  , 0.382 , 0.6033 , 0.4044 , 0.2
Data 0.382 ,  0.0  , 0.0  , 0.382 , 0.0139 , 0.4044 , 0.2
Data 0.382 ,  0.0  , 0.0  , 0.382 , 0.1253 , 0.0595 , 0.2
Data 0.382 ,  0.0  , 0.0  , 0.382 , 0.4920 , 0.0595 , 0.2
;0.02  ,  0.1  , 0.98 , 1.05 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)
;erstellt von Th. Erken

.galaxieData
Data 4	 			;number of rows (coefficients)
Data 62.0, 62.0		;x and y multiplication factors
Data 512, -370		;x and y offsets 
;Galaxie
Data 0.85 ,  0.15 , -0.15 , 0.85 ,  1.0 ,  1.0 , 0.25
Data 0.85 , -0.15 ,  0.15 , 0.85 , -1.0 ,  1.0 , 0.25
Data 0.65 , -0.45 ,  0.45 , 0.65 , -1.0 , -1.0 , 0.25
Data 0.65 ,  0.45 , -0.45 , 0.65 ,  1.0 , -1.0 , 0.25
;-8.0 , -7.0  ,  8.0  , 8.2 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.gartenData			;Garden
Data 3	 			;number of rows (coefficients)
Data 380.0, 380.0	;x and y multiplication factors
Data 135, -5		;x and y offsets 
;Cantor-Garten
Data 0.336 ,  0.0   , 0.0 , 0.335 , 0.662 , 1.333 , 0.33
Data 0.0   ,  0.333 , 1.0 , 0.0   , 1.333 , 0.0   , 0.33
Data 0.0   , -0.333 , 1.0 , 0.0   , 0.666 , 0.0   , 0.34
;0.0   ,  0.0   , 2.0 , 2.2 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)
;erstellt von Th. Erken unter Verwendung von WIN-Funktion

.kochKurveData
Data 4	 			;number of rows (coefficients)
Data 1015.0, 970.0	;x and y multiplication factors
Data 5, -250		;x and y offsets 
;Koch-Kurve
Data  0.333 ,  0.0     , 0.0     , 0.333 , 0.0   , 0.0 , 0.25
Data  0.333 ,  0.0     , 0.0     , 0.333 , 0.666 , 0.0 , 0.25
Data  0.166 , -0.28867 , 0.28867 , 0.166 , 0.333 , 0.0 , 0.25
Data -0.166 ,  0.28867 , 0.28867 , 0.166 , 0.666 , 0.0 , 0.25
;-0.01  , -0.2     , 1.01    , 0.6 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)
;erstellt von Th. Erken

.quadKochData
Data 5	 			;number of rows (coefficients)
Data 1015.0, 970.0	;x and y multiplication factors
Data 5, -150		;x and y offsets 
;quadratische Koch-Kurve
Data 0.333 ,  0.0   ,  0.0   , 0.333 , 0.0   , 0.0   , 0.2
Data  0.0   , -0.333 ,  0.333 , 0.0   , 0.333 , 0.0   , 0.2
Data 0.333 ,  0.0   ,  0.0   , 0.333 , 0.333 , 0.333 , 0.2
Data 0.0   ,  0.333 , -0.333 , 0.0   , 0.666 , 0.333 , 0.2
Data 0.333 ,  0.0   ,  0.0   , 0.333 , 0.666 , 0.0   , 0.2
;-0.01  , -0.1   ,  1.01  , 0.7 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)
;erstellt von Th. Erken

.minkowskiData
Data 8	 			;number of rows (coefficients)
Data 1015.0, 970.0	;x and y multiplication factors
Data 5, -380		;x and y offsets 
;Minkowski-Fraktal
Data  0.25 ,  0.0  ,  0.0  ,  0.25 ,  0.0  ,  0.0  , 0.125
Data  0.0  , -0.25 ,  0.25 ,  0.0  ,  0.25 ,  0.0  , 0.125
Data  0.25 ,  0.0  ,  0.0  ,  0.25 ,  0.25 ,  0.25 , 0.125
Data  0.0  ,  0.25 , -0.25 ,  0.0  ,  0.5  ,  0.25 , 0.125
Data  0.0  ,  0.25 , -0.25 ,  0.0  ,  0.5  ,  0.0  , 0.125
Data  0.25 ,  0.0  ,  0.0  ,  0.25 ,  0.5  , -0.25 , 0.125
Data  0.0  , -0.25 ,  0.25 ,  0.0  ,  0.75 , -0.25 , 0.125
Data  0.25 ,  0.0  ,  0.0  ,  0.25 ,  0.75 ,  0.0  , 0.125
;-0.01 , -0.35 ,  1.01 ,  0.4 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)
;erstellt von Th. Erken

.schneckenhausData	;Snail shell
Data 2	 			;number of rows (coefficients)
Data 480.0, 438.0	;x and y multiplication factors
Data 490, -307		;x and y offsets 
;Schneckenhaus 
Data  0.933084 , -0.250020 , 0.250020 ,  0.933084 , 0.00 , 0.00 , 0.907884 
Data -0.261559 , -0.037628 , 0.027489 , -0.358028 , 0.71 , 0.58 , 0.092116 
;-1.1, -0.78, 1.15,  1.22 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995) 
;erstellt mit XIFS von H.D. Winkler und R. Seidel

.schnurData			;Cord
Data 2	 			;number of rows (coefficients)
Data 1.65, 1.65		;x and y multiplication factors
Data -20, -5		;x and y offsets
;Schnur
Data  0.8241 , -0.2815 ,   0.2123 ,   0.8642 ,  85.692  ,   0.8988 , 0.8 
Data -0.0722 , -0.4222 ,  -0.2463 ,   0.0593 , 686.1454 , 189.8652 , 0.2 
;10.0 ,15.0, 640.0, 475.0 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995) 
;erstellt von Th. Erken unter Verwendung von Angaben aus FDESIGN

.sierpCarpetData
Data 8	 			;number of rows (coefficients)
Data 750.0, 750.0	;x and y multiplication factors
Data 140, -10		;x and y offsets
;SeirpinskiCarpet
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.0   , 0.0   , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.333 , 0.0   , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.666 , 0.0   , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.0   , 0.333 , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.0   , 0.666 , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.666 , 0.333 , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.666 , 0.666 , 0.125
Data  0.333 ,  0.0  , 0.0 , 0.333 , 0.333 , 0.666 , 0.125
;-0.15  , -0.05 , 1.2 , 1.1
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.sierpinskiTriData
Data 3	 			;number of rows (coefficients)
Data 450.0, 750.0	;x and y multiplication factors
Data 60, -7			;x and y offsets
;Sierpinski-Dreieck
Data 0.5  ,  0.0  , 0.0 , 0.5 , 0.0 , 0.0 , 0.33
Data 0.5  ,  0.0  , 0.0 , 0.5 , 1.0 , 0.0 , 0.33
Data 0.5  ,  0.0  , 0.0 , 0.5 , 0.5 , 0.5 , 0.34
;-0.05 , -0.03 , 2.1 , 1.05
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.sierpTriData		;Distorted Sierpinski Triangle
Data 3	 			;number of rows (coefficients)
Data 350.0, 550.0	;x and y multiplication factors
Data 170, -200		;x and y offsets
;Verzerrtes Sierpinski-Dreieck
Data 0.5  , -0.09 ,  0.09 , 0.5 , 0.0 , 0.0 , 0.33
Data 0.5  ,  0.09 , -0.09 , 0.5 , 1.0 , 0.0 , 0.33
Data 0.5  ,  0.0  ,  0.0  , 0.5 , 0.5 , 0.5 , 0.34
;-0.05 , -0.03 ,  2.1  , 1.05
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.steineData			;Bricks
Data 4	 			;number of rows (coefficients)
Data 250.0, 270.0	;x and y multiplication factors
Data 13, -110		;x and y offsets
;Backsteine
Data  0.5 ,  0.0 , 0.0 , 0.5 , 0.0 , 0.0 , 0.25
Data  0.5 ,  0.0 , 0.0 , 0.5 , 2.0 , 0.0 , 0.25
Data  0.4 ,  0.0 , 0.0 , 0.4 , 0.0 , 1.0 , 0.25
Data  0.5 ,  0.0 , 0.0 , 0.5 , 2.0 , 1.0 , 0.25
;-0.1 , -0.1 , 4.2 , 2.4
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

.spitzahornblattData	;Maple Leaf
Data 4	 				;number of rows (coefficients)
Data 700.0, 590.0		;x and y multiplication factors
Data 155, -70			;x and y offsets
;Spitzahornblatt
Data  0.35  , -0.45 ,  0.35 , 0.45 , 0.25 ,  0.0  , 0.31
Data  0.35  ,  0.45 , -0.35 , 0.45 , 0.4  ,  0.35 , 0.31
Data  0.5   ,  0.0  ,  0.0  , 0.8  , 0.25 ,  0.25 , 0.34
Data  0.02  ,  0.0  ,  0.0  , 0.45 , 0.49 , -0.1  , 0.04
; -0.45  , -0.3  ,  1.5  , 1.45 (Window viewport size)
;IFS-Datei fr RS-IFS von Robert Seidel (1995)
;(nach Skizzen berechnet) von Th. Erken
;Reihenfolge der Abb.: linkes, rechtes, mittleres Teilblatt, Stiel

.zweigData				;Branch with buds
Data 3	 				;number of rows (coefficients)
Data 1170.0, 1200.0		;x and y multiplication factors
Data 0, 210				;x and y offsets
;Zweig mit Knospen
Data -0.467 ,  0.02  , -0.113 ,  0.015 , 0.4   , 0.4   , 0.2
Data  0.387 ,  0.43  ,  0.43  , -0.387 , 0.256 , 0.522 , 0.6
Data  0.441 , -0.091 , -0.009 , -0.322 , 0.422 , 0.506 , 0.4 
;-0.04  ,  0.15  ,  0.95  ,  0.86
;IFS-Datei fr RS-IFS von Robert Seidel (1995)

;============================================================================
;	End of RS-IFSPB.BAS values
;============================================================================



Function speed0(choice%, numRows%, xalt#, yalt#, xMult#, yMult#, xOffset%, yOffset%, band#, coff#)
	Local kk%, jj%, ii%, pixel#, x#, y#, xp%, yp%, clr%
	
	For kk = 1 To 5000
		For jj = 1 To 10
			pixel=Rnd(0.0,1.0)
			For ii = 1 To numRows
				If pixel <= p(ii) Then Exit
			Next
			If ii > numRows Then ii = numRows
			x = a(ii) * xalt + b(ii) * yalt + e(ii)
			y = c(ii) * xalt + d(ii) * yalt + f(ii)
			xp = Int(x*xMult) + xOffset 
			yp = (768-Int(y*yMult)) + yOffset
			If choice = 4 Then
				clr% = Int(yp/32)
			Else
				clr% = Int(Sqr((cx-xp)*(cx-xp) + (cy-yp)*(cy-yp))/band + coff) Mod 24
			End If
			Color rr(clr), gg(clr), bb(clr)
			If xp>=0 And xp<1024 And yp>=0 And yp<768 Then Plot xp, yp
			xalt = x : yalt = y
		Next
		Flip False
		If KeyHit(1) Then End
	Next
End Function

Function speed1(choice%, numRows%, xalt#, yalt#, xMult#, yMult#, xOffset%, yOffset%, band#, coff#)
	Local kk%, jj%, ii%, pixel#, x#, y#, xp%, yp%, clr%
	LockBuffer()
	For kk = 1 To 10000
		For jj = 1 To 5
			pixel=Rnd(0.0,1.0)
			For ii = 1 To numRows
				If pixel <= p(ii) Then Exit
			Next
			If ii > numRows Then ii = numRows
			x = a(ii) * xalt + b(ii) * yalt + e(ii)
			y = c(ii) * xalt + d(ii) * yalt + f(ii)
			xp = Int(x*xMult) + xOffset 
			yp = (768-Int(y*yMult)) + yOffset
			If choice = 4 Then
				clr = Int(yp/32)
			Else
				clr = Int(Sqr((cx-xp)*(cx-xp) + (cy-yp)*(cy-yp))/band + coff) Mod 24
			End If
			If xp>=0 And xp<1024 And yp>=0 And yp<768 Then
				WritePixelFast(xp,yp,hxc(clr))
			End If
	        xalt = x : yalt = y
    	Next
	Next
	UnlockBuffer()
End Function

Function h2d$(hx$)
	Local hi%, lo%
	
	hx$ = Upper(hx$)
	hi = Asc( Left(hx$,1))-48
	lo = Asc(Right(hx$,1))-48
	If hi>10 Then hi=hi-7
	If lo>10 Then lo=lo-7
	
	Return hi Shl 4 Or lo
End Function

Function drawBox (msg$,x%,y%,w%=40,h%=20,rbox%=255,gbox%=255,bbox%=255, rtext%=0,gtext%=0,btext%=0)
	Color rbox,gbox,bbox
	Rect x,y,w,h,True
	Color rtext,gtext,btext
	Text x+3,y+3,msg$
End Function

Function Menu%()
	Local i%, mx%, my%, response% = 0 
	While response=0
		If KeyHit(1) Then End
		drawBox ("Next", 980,  5,38,19, 80, 80, 80,255,255,255)
		drawBox ("Prev", 980, 30,38,19, 80, 80, 80,255,255,255)
		drawBox ("Fast", 980, 55,38,19, 80, 80, 80, 64,255, 64)
		drawBox ("Slow", 980, 80,38,19, 80, 80, 80,255,255, 32)
		drawBox ("EXIT", 980,105,38,19,144,  0,  0,255,255,255)
		Flip
		WaitMouse()
		mx = MouseX(): my = MouseY()
		For i = 0 To 4
			If pnr(mx,my, 980, i*25+5, 38, 19)=1 Then
				response = i+1
				Exit
			End If
		Next
		If KeyHit(1) Then End
		FlushMouse()
	Wend
	Return response
End Function

Function hilite(x,y,w,h)
	Color 255,255,255
	Rect x-2,y-2,w+4,h+4,False
	Rect x-1,y-1,w+2,h+2,False
End Function

Function pnr(px, py, rx, ry, rw, rh)
;====================================================================================
;   Function "Point In Rectangle"
;====================================================================================
; This function checks to see if the point (px,py) is within the specified rectangle.
;
; If the point is inside the rectangle a value of 1 is returned.
;
; If the point is NOT inside the rectangle a value of 0 (zero) is returned.
;====================================================================================
; px = the X coord of the point in question
; py = the Y coord of the point in question
; rx = Upper  Left X coord of rectangle
; ry = Upper  Left Y coord of rectangle
; rw =  width of rectangle
; rh = height of rectangle
;====================================================================================
    Return ((px>=rx) And (px<=(rx+rw-1)) And (py>=ry) And (py<=(ry+rh-1)))
End Function

.palette
;Read in hex color triplets
Dim rr%(24), gg%(24), bb%(24), hxc%(24)
Restore rainbow
count% = 0
For i% = 1 To 3
	Read hx8$
	For j% = 1 To 43 Step 6
		triplet$ = Mid(hx8$,j,6)
		rr%(count) = h2d$(Mid(triplet$,1,2))
		gg%(count) = h2d$(Mid(triplet$,3,2))
		bb%(count) = h2d$(Mid(triplet$,5,2))
		hxc%(count) = rr%(count) Shl 16 Or gg%(count) Shl 8 Or bb%(count)
		count = count + 1
	Next
Next
Return
.rainbow
Data "0000FF4000FF7D00FFBE00FFFF00FFFF00BEFF007DFF0040"
Data "FF0000FF4000FF7D00FFBE00FFFF00BEFF007DFF0040FF00"
Data "00FF0000FF4000FF7D00FFBE00FFFF00BEFF007DFF0040FF"


.hexPal
;Read in hex color triplets
Restore fbHexPalette
count% = 0
For ii% = 1 To 31
	Read v8$
	For jj% = 1 To 43 Step 6
		trip$ = Mid(v8$,jj,6)
		rr%(count) = h2d$(Mid(trip$,1,2))
		gg%(count) = h2d$(Mid(trip$,3,2))
		bb%(count) = h2d$(Mid(trip$,5,2))
		hxc%(count) = rr%(count) Shl 16 Or gg%(count) Shl 8 Or bb%(count)
		count = count + 1
	Next
Next
Return

.fbHexPalette
Data "0000000000AA00AA0000AAAAAA0000AA00AAAA5500AAAAAA"
Data "5555555555FF55FF5555FFFFFF5555FF55FFFFFF55FFFFFF"
Data "0000001414142020202C2C2C383838444444505050616161"
Data "717171818181919191A1A1A1B6B6B6CACACAE2E2E2FFFFFF"
Data "0000FF4000FF7D00FFBE00FFFF00FFFF00BEFF007DFF0040"
Data "FF0000FF4000FF7D00FFBE00FFFF00BEFF007DFF0040FF00"
Data "00FF0000FF4000FF7D00FFBE00FFFF00BEFF007DFF0040FF"
Data "7D7DFF9D7DFFBE7DFFDE7DFFFF7DFFFF7DDEFF7DBEFF7D9D"
Data "FF7D7DFF9D7DFFBE7DFFDE7DFFFF7DDEFF7DBEFF7D9DFF7D"
Data "7DFF7D7DFF9D7DFFBE7DFFDE7DFFFF7DDEFF7DBEFF7D9DFF"
Data "B6B6FFC6B6FFD4B6FFEAB6FFFFB6FFFFB6EAFFB6DAFFB6C6"
Data "FFB6B6FFC6B6FFDAB6FFEAB6FFFFB6EAFFB6DAFFB6C6FFB6"
Data "B6FFB6B6FFC6B6FFDAB6FFEAB6FFFFB6EAFFB6DAFFB6C6FF"
Data "0000711C007138007155007171007171005571003871001C"
Data "710000711C007138007155007171005571003871001C7100"
Data "00710000711C007138007155007171005571003871001C71"
Data "383871443871553871613871713871713861713855713844"
Data "713838714438715538716138717138617138557138447138"
Data "387138387144387155387161387171386171385571384471"
Data "505071595071615071695071715071715069715061715059"
Data "715050715950716150716950717150697150617150597150"
Data "507150507159507161507169507171506971506171505971"
Data "000040100040200040300040400040400030400020400010"
Data "400000401000402000403000404000304000204000104000"
Data "004000004010004020004030004040003040002040001040"
Data "202040282040302040382040402040402038402030402028"
Data "402020402820403020403820404020384020304020284020"
Data "204020204028204030204038204040203840203040202840"
Data "2C2C40302C40342C403C2C40402C40402C3C402C34402C30"
Data "402C2C40302C40342C403C2C40402C3C402C34402C30402C"
Data "2C402C2C40302C40342C403C2C40402C3C402C34402C3040"